/**
 * Quad Sim v0.21
 * Copyright (C) 2005  Giliam de Carpentier
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * You can contact me at giliam@decarpentier.nl for questions concerning this license.
 */
// included by "common.h"
#ifndef MAP_H
#define MAP_H

class VMAP {
public:
	int u, v;
	inline VMAP() {}
	inline VMAP(int u, int v) {
	this->u = u; this->v = v;}
};

class MAP {
	float *pfMap;
	V *pvMapN1, *pvMapN2;
	int readFile (const char *pcFN);
	V vertexColor(const V &v3, bool offset);
public:
	MAP(const char *pcFN);

	V m2w(int u, int v);
	VMAP w2m(const V &v);

	float tileDist(const V &v, V *vRet);
	float heightAt(float x, float z);
	V force(const MP *pmp);
	V force(const MP *pmp, float cFric, float cFric0, V vProf, float cProf);

	void render(const V &vc);

};
#endif
